MyAddon = LibStub("AceAddon-3.0"):NewAddon("EPGP Looting Guide", "AceEvent-3.0", "AceConsole-3.0", "AceComm-3.0")

AceGUI = LibStub("AceGUI-3.0")

local libS = LibStub:GetLibrary("AceSerializer-3.0")
local libC = LibStub:GetLibrary("LibCompress")
local libCE = libC:GetAddonEncodeTable()

local epgpEnable
local groupEnable
local masterlootEnable

myOptions = {
  name = "Global Options",
  type = "group",
  args = {
    enable = {
      name = "Enable Addon",
      desc = "Enables / Disables the addon",
      type = "toggle",
      set = function(info,val) if (val) then MyAddon:Enable() else MyAddon:Disable() end MyAddon.enabled = val end,
      get = function(info) return MyAddon.enabled end
    },
	group = {
      name = "Enable Groups",
      desc = "Enables / Disables the addon for groups",
      type = "toggle",
      set = function(info,val) MyAddon.db.profile.groupEnable = val end,
      get = function(info) return MyAddon.db.profile.groupEnable end
    },
	masterloot = {
      name = "Enable MasterLooter",
      desc = "Enables / Disables the addon for Master Looter tracking",
      type = "toggle",
      set = function(info,val) MyAddon.db.profile.masterlootEnable = val end,
      get = function(info) return MyAddon.db.profile.masterlootEnable end
    },
	epgp = {
      name = "Enable EPGP Prices",
      desc = "Enables / Disables the addon showing the EPGP Prices",
      type = "toggle",
      set = function(info,val) MyAddon.db.profile.epgpEnable = val end,
      get = function(info) return MyAddon.db.profile.epgpEnable end
    },
	wish = {
	  name = "Wish List",
	  desc = "Opens the Wish List, to set up the list of items to look out for",
	  type = "execute",
	  func = function() WishListFrame() end,
	},
	
	epgpprices = {
		name = "Custom Prices",
		type = "group",
		args = {
			customValues = {
				name = "Enable Custom Values",
				desc = "Enables / Disables the addon using Custom Values",
				type = "toggle",
				set = function(info,val) MyAddon.db.profile.inGuild = val end,
				get = function(info) return MyAddon.db.profile.inGuild end
			},
			customName = {
				name = "Enter Loot System Name",
				desc = "Enter the name of the Loot system you use with a Fixed Price System",
				type = "input",
				set = function(info,val) MyAddon.db.profile.system = val end,
				get = function(info) return MyAddon.db.profile.system end
			},
			values = {
				name = "Values",
				type = "group",
				args = {
					helm = {
						name = "Helmet Price",
						desc = "Input the custom Helmet Price (including Tokens)",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.HelmGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.HelmGP) end
					},
					neck = {
						name = "Neck Price",
						desc = "Input the custom Neck Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.NeckGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.NeckGP) end
					},
					shoulder = {
						name = "Shoulders Price",
						desc = "Input the custom Shoulders Price (including Tokens)",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.ShouldersGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.ShouldersGP) end
					},
					cloak = {
						name = "Cloak Price",
						desc = "Input the custom Cloak Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.CloakGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.CloakGP) end
					},
					chest = {
						name = "Chest Piece Price",
						desc = "Input the custom Chest Piece Price (including Tokens)",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.ChestGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.ChestGP) end
					},
					wrist = {
						name = "Wrist Price",
						desc = "Input the custom Wrist Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.WristGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.WristGP) end
					},
					glove = {
						name = "Gloves Price",
						desc = "Input the custom Gloves Price (including Tokens)",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.GlovesGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.GlovesGP) end
					},
					waist = {
						name = "Waist Price",
						desc = "Input the custom Waist Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.WaistGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.WaistGP) end
					},
					legs = {
						name = "Leg Piece Price",
						desc = "Input the custom Legs Piece Price (including Tokens)",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.LegsGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.LegsGP) end
					},
					boots = {
						name = "Boots Price",
						desc = "Input the custom Boots Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.BootsGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.BootsGP) end
					},
					ring = {
						name = "Ring Price",
						desc = "Input the custom Ring Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.RingGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.RingGP) end
					},
					trinket = {
						name = "Trinket Price",
						desc = "Input the custom Trinket Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.TrinketGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.TrinketGP) end
					},
					mainhand = {
						name = "Mainhand Weapon Price",
						desc = "Input the custom Mainhand Weapon Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.MainhandGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.MainhandGP) end
					},
					offhand = {
						name = "Offhand Price",
						desc = "Input the custom Offhand (Weapons/Shields) Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.OffhandGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.OffhandGP) end
					},
					twohand = {
						name = "Two Handed Weapon Price",
						desc = "Input the custom Two Handed Weapon Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.WeaponGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.WeaponGP) end
					},
					ranged = {
						name = "Ranged Weapon Price",
						desc = "Input the custom Ranged Weapon(Relic/Wands/Bows etc) Price",
						type = "input",
						set = function(info,val) MyAddon.db.profile.custom.RangedGP = val end,
						get = function(info) return tostring(MyAddon.db.profile.custom.RangedGP) end
					},
				},
			},
		},
	},
  }
}

local AceConfig = LibStub("AceConfig-3.0")
AceConfig:RegisterOptionsTable("EPGP Looting Guide", myOptions)
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("EPGP Looting Guide")

local frame
local slotID
local sName
local sLink
local iRarity
local iLevel
local dropppediLevel
local sType
local sSubType
local sEquip
local sTexture
local statsTable = {}
local tablePrio = {}
local iEPGPCost
local primaryStat
local stats = {}
local comparing = false
local compareGroup
local typeOfItem
local typeOfItem1
local lootID
local isLockbox = false
local MLEPGPCost
local LootSystem
local droppedItems = {}
local droppedIDs = {}
local numberDrops = 0
local tab
local MLTablePrio = {}
local lineAdded = false
local MLsTexture
local isOpen = false
local wishText
local dropID

local defaults = {
  profile = {
	droppedItemLink = "",
	isOpen = false,
	inGuild = false,
	system = "EPGP",
	groupEnable = true,
	masterlootEnable = true,
	epgpEnable = true,
	point = "CENTER",
	relPoint = "CENTER",
	x = 0,
	y = 0,
		epgp = {
			HelmGP = 1,
			NeckGP = 0.55,
			ShouldersGP = 0.777,
			CloakGP = 0.55,
			ChestGP = 1,
			WristGP = 0.777,
			GlovesGP = 0.777,
			WaistGP = 0.777,
			LegsGP = 1,
			BootsGP = 0.777,
			RingGP = 0.55,
			TrinketGP = 0.7,
			MainhandGP = 0.42,
			OffhandGP = 0.55,
			WeaponGP = 1,
			RangedGP = 0.42,
		},
		custom = {
			HelmGP = 2200,
			NeckGP = 1250,
			ShouldersGP = 1650,
			CloakGP = 1250,
			ChestGP = 2200,
			WristGP = 1250,
			GlovesGP = 1650,
			WaistGP = 1650,
			LegsGP = 2200,
			BootsGP = 1650,
			RingGP = 1250,
			TrinketGP = 1650,
			MainhandGP = 2450,
			OffhandGP = 950,
			WeaponGP = 3400,
			RangedGP = 700,
		},
		wishlist = {
			items = {},
		},
	}
}

function MyAddon:OnInitialize()
	MyAddon.enabled = true
	local guildName = GetGuildInfo(UnitName("player"))

	self.db = LibStub("AceDB-3.0"):New("EPGPLootingGuideDB1", defaults)
	
	MyAddon.db.profile.isOpen = false

	MyAddon:RegisterChatCommand("epgplg", "ChatCommand")
	
	--MyAddon:RegisterEvent("PLAYER_LOGIN", test)
end

	local LOOT_SELF_REGEX = gsub(LOOT_ITEM_SELF, "%%s", "(.+)")
	local LOOT_REGEX = gsub(LOOT_ITEM, "%%s", "(.+)")

function MyAddon:OnEnable()
	if (MyAddon.db.profile.groupEnable) then
		MyAddon:RegisterEvent("START_LOOT_ROLL")
	end
	if (MyAddon.db.profile.masterlootEnable) then		
		MyAddon:RegisterEvent("OPEN_MASTER_LOOT_LIST")
	end
	MyAddon:RegisterComm("LootingGuideNI")
	
	Pre_WoW_Rollonloot = RollOnLoot
	RollOnLoot = LootRoll
end

function MyAddon:ChatCommand(input)
	if not input or input:trim() == "" then
		LibStub("AceConfigDialog-3.0"):Open("EPGP Looting Guide")
	elseif input == "enable" then
		MyAddon:Enable()
		MyAddon:Print("EPGP Looting Guide is now Enabled")
	elseif input == "disable" then
		MyAddon:Disable()
		MyAddon:Print("EPGP Looting Guide is now Disabled")
	end
end

function MyAddon.START_LOOT_ROLL(_,_,id)
	MyAddon.db.profile.droppedItemLink = GetLootRollItemLink(id)
	lootID = id		
	sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(MyAddon.db.profile.droppedItemLink)

	if (sType == "Armor" or sType == "Weapon" or (sType == "Miscellaneous" and sSubType == "Junk" and dropppediLevel > 69)) then
		if (sType == "Miscellaneous" and dropppediLevel > 69) then 
			ToolTipScanner(true)
		end

		if (isLockbox == false) then
			numberDrops = numberDrops + 1			
			table.insert(droppedIDs, MyAddon.db.profile.droppedItemLink)
			local i = tablelength(droppedItems)
			table.insert(droppedItems, {value = i, text = sName})
			ActivatePrint()
			tab:SelectTab(0)
			table.wipe(tablePrio)
		end
	end	
end

function MyAddon.OPEN_MASTER_LOOT_LIST()
	MyAddon.db.profile.droppedItemLink = GetLootSlotLink(LootFrame.selectedSlot)
	
	sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(MyAddon.db.profile.droppedItemLink)
	
	if (sType == "Armor" or sType == "Weapon" or (sType == "Miscellaneous" and sSubType == "Junk" and dropppediLevel > 69)) then
		if (sType == "Miscellaneous" and dropppediLevel > 69) then 
			ToolTipScanner(true)
		end
		if (isLockbox == false) then
			table.insert(droppedIDs, MyAddon.db.profile.droppedItemLink)
			local i = tablelength(droppedItems)
			table.insert(droppedItems, {value = i, text = sName})
			ActivatePrint()
			tab:SelectTab(0)
			local table = libS:Serialize(tablePrio)
			local data = MyAddon.db.profile.system.."/"..iEPGPCost.."/"..sName.."/"..sLink.."/"..iRarity.."/"..dropppediLevel.."/"..sType.."/"..sSubType.."/"..sEquip.."/"..sTexture.."/"..table
			local serial = libS:Serialize(data)
			local compress = libC:CompressHuffman(serial)
			local sendMessage = libCE:Encode(compress)
			MyAddon:SendCommMessage("LootingGuideNI", sendMessage, "RAID")
			MyAddon:RegisterEvent("CHAT_MSG_LOOT")
			tablePrio = {}
		end		
	else
		slotID = nil
	end	
end

local function OnTooltipSetItem(tooltip, ...)
	if not lineAdded then
		local _, linkTool = tooltip:GetItem()

		if (IsEquippableItem(linkTool) ~= nil) then
			sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(linkTool)	
			stats = GetItemStats(sLink, statsTable)
			WorkoutPrimary()
			iLevel = dropppediLevel
			EquipPrio()
			sort(tablePrio, function(a,b) return a.prio > b.prio end)
			for _, v in pairs(tablePrio) do
				if (v.prio > 4) then
					tooltip:AddLine("Looting Guide: "..v.prio.." - "..v.spec)
				end
			end
			table.wipe(tablePrio)
			table.wipe(stats)
			lineAdded = true
		end
	end
end

local function OnTooltipCleared(tooltip, ...)
   lineAdded = false
end

GameTooltip:HookScript("OnTooltipSetItem", OnTooltipSetItem)
GameTooltip:HookScript("OnTooltipCleared", OnTooltipCleared)


function LootRoll(Rollid, roll)
	if MyAddon.db.profile.isOpen then
		numberDrops = numberDrops - 1
		if (numberDrops == 0) then
			SaveFramePosition()
			MyAddon.db.profile.isOpen = false
			table.wipe(droppedIDs)
			table.wipe(droppedItems)
			AceGUI:Release(frame)					
		end
	end
	Pre_WoW_Rollonloot(Rollid, roll)
end


function MyAddon:CHAT_MSG_LOOT(n, lootmsg)
    if MyAddon.db.profile.isOpen then
		local _, _, sPlayer, ditemlink = string.find(lootmsg, LOOT_REGEX)
		if not sPlayer then _, _, ditemlink = string.find(lootmsg, LOOT_SELF_REGEX) end
		if not ditemlink then return end
		if (ditemlink == MyAddon.db.profile.droppedItemLink) then
			SaveFramePosition()
			MyAddon.db.profile.isOpen = false
			table.wipe(droppedIDs)
			table.wipe(droppedItems)
			MLsTexture = nil
			AceGUI:Release(frame)						
		end
	end
end

function test()
	local id = 77221		
	sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(id)
	
	if (sType == "Armor" or sType == "Weapon" or (sType == "Miscellaneous" and sSubType == "Junk" and dropppediLevel > 69)) then
		ToolTipScanner(true)
		if (isLockbox == false) then
			MyAddon.db.profile.droppedItemLink = sLink
			table.insert(droppedIDs, id)
			local i = tablelength(droppedItems)
			table.insert(droppedItems, {value = i, text = sName})
			ActivatePrint()
			table.wipe(tablePrio)
		end
	end
end

function MyAddon:OnCommReceived(prefix, message, distribution, sender)
	local playerName = UnitName("player")
	if (sender ~= playerName) then
		if (prefix == "LootingGuideNI") then
			local decode = libCE:Decode(message)
			local decompress, errMess = libC:Decompress(decode)
			
			if(not decompress) then
				MyAddon:Print("Error decompressing: " ..errMess)
				return
			end

			local success, final = libS:Deserialize(decompress)
			if(not success) then
				MyAddon:Print("Error deserializing: " ..final)
				return
			end

			local rTable
			local dILvl
			LootSystem, MLEPGPCost, sName, sLink, iRarity, dILvl, sType, sSubType, sEquip, MLsTexture, rTable = strsplit("/", final)

			dropppediLevel = tonumber(dILvl)

			local success, sTable = libS:Deserialize(rTable)
			if(not success) then
				MyAddon:Print("Error deserializing: " ..sTable)
				return
			end

			MLTablePrio = sTable

			MyAddon.db.profile.droppedItemLink = sLink
			table.insert(droppedIDs, MyAddon.db.profile.droppedItemLink)
			local i = tablelength(droppedItems)
			table.insert(droppedItems, {value = i, text = sName})
			ActivatePrint()
			tab:SelectTab(0)
			MyAddon:RegisterEvent("CHAT_MSG_LOOT")
		end
	end
end

function ActivatePrint()
	if (MyAddon.db.profile.isOpen ~= true) then
		MyAddon.db.profile.isOpen = true
				
		frame = AceGUI:Create("Frame")

		LoadFramePosition()

		frame:SetTitle("EPGP Looting Guide")
		frame:SetCallback("OnClose", function(frame) SaveFramePosition() MyAddon.db.profile.isOpen = false table.wipe(droppedIDs) table.wipe(droppedItems) MLsTexture = nil AceGUI:Release(frame) end)			
		frame:SetLayout("Fill")
		frame:SetWidth(250)
		local i = tablelength(droppedItems)
		i = i - 1
		local height = 375 + (18 * i)
		frame:SetHeight(height)
		frame:EnableResize(Hide)

		tab = AceGUI:Create("TabGroup")
		tab:SetLayout("Flow")
		tab:SetTabs(droppedItems)
		tab:SetCallback("OnGroupSelected", SelectGroup)
		tab:SelectTab(0)

		frame:AddChild(tab)	
	else
		local i = tablelength(droppedItems)
		i = i - 1
		local height = 375 + (18 * i)
		frame:SetHeight(height)

	end
end

function SelectGroup(container, event, group)
	container:ReleaseChildren()
	typeOfItem1 = nil
	SaveFramePosition()

	if (comparing == false) then		
		local index = group + 1
		if (MLsTexture ~= nil) then
			sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, _ = GetItemInfo(droppedIDs[index])
			MyAddon.db.profile.droppedItemLink = sLink
		else
			sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(droppedIDs[index])
			MyAddon.db.profile.droppedItemLink = sLink
		end
		DrawGroup(container)
	else
		comparing = false		
		local index = group + 1
		if (MLsTexture ~= nil) then
			sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip = GetItemInfo(droppedIDs[index])
			MyAddon.db.profile.droppedItemLink = sLink
		else
			sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(droppedIDs[index])
			MyAddon.db.profile.droppedItemLink = sLink
		end
		MyAddon.db.profile.isOpen = false
		AceGUI:Release(frame)		
		ActivatePrint()
		tab:SelectTab(group)
	end	
end

function DrawGroup(container)
	
	if (MLEPGPCost == nil)	then
		stats = GetItemStats(sLink, statsTable)
	end

	WorkOutEPGP()
		
	local itemGroup = AceGUI:Create("InlineGroup")
	itemGroup:SetTitle("Dropped Item")
	itemGroup:SetWidth(197)
	itemGroup:SetFullHeight(true)
	itemGroup:SetLayout("List")
	container:AddChild(itemGroup)
	
	local link = MyAddon.db.profile.droppedItemLink

	local pic = AceGUI:Create("Icon")
	if (MLsTexture ~= nil) then
		pic:SetImage(MLsTexture)
	else
		pic:SetImage(sTexture)
	end
	
	pic:SetWidth(165)
	pic:SetImageSize(40, 40)
	pic:SetCallback("OnEnter", function(pic) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(link) if isOpen == true then  wishText:SetText(link) end end)
	pic:SetCallback("OnLeave", function(pic) GameTooltip:Hide() end)
	itemGroup:AddChild(pic)

	local linebreak = AceGUI:Create("Label")
	linebreak:SetText(" ")
	itemGroup:AddChild(linebreak)
	
	local wishLabel = AceGUI:Create("Label")
	wishLabel:SetFullWidth(true)
	wishLabel:SetColor(1,0.8,0)
	itemGroup:AddChild(wishLabel)

	if (MyAddon.db.profile.epgpEnable or MLEPGPCost ~= nil) then
		local epgp = AceGUI:Create("Label")
			 
		if (MLEPGPCost ~= nil) then
			epgp:SetText("             "..LootSystem.." Cost: "..MLEPGPCost)
		else
			LootSystem = MyAddon.db.profile.system
			epgp:SetText("             "..LootSystem.." Cost: "..iEPGPCost)
		end
		itemGroup:AddChild(epgp)
	end

	local linebreak = AceGUI:Create("Label")
	linebreak:SetText(" ")
	itemGroup:AddChild(linebreak)
	
	if (MLEPGPCost == nil)	then
		WorkoutPrimary()
	end
	
	local group = AceGUI:Create("InlineGroup")	
	group:SetTitle("Priorities")
	group:SetFullWidth(itemGroup)
	group:SetHeight(45)
	
	group:SetLayout("Fill")
	itemGroup:AddChild(group)

	scroll = AceGUI:Create("ScrollFrame")
	scroll:SetLayout("Flow")
	group:AddChild(scroll)

	if (MLEPGPCost ~= nil)	then
		tablePrio = MLTablePrio
	end

	sort(tablePrio, function(a,b) return a.prio > b.prio end)
	for _, v in pairs(tablePrio) do
		if (v.prio > 4) then
			local itemPrio = AceGUI:Create("Label")
			if (v.prio > 13) then
				itemPrio:SetColor(1.0,0,0)
			elseif (v.prio == 13) then
				itemPrio:SetColor(1,0.2,0)
			elseif (v.prio == 12) then
				itemPrio:SetColor(1,0.4,0)
			elseif (v.prio == 11) then
				itemPrio:SetColor(1,0.6,0)
			elseif (v.prio == 10) then
				itemPrio:SetColor(1,0.8,0)
			elseif (v.prio == 9) then
				itemPrio:SetColor(1,1,0)
			elseif (v.prio == 8) then
				itemPrio:SetColor(0.2,1,0)
			elseif (v.prio == 7) then
				itemPrio:SetColor(0,1,0)
			elseif (v.prio == 6) then
				itemPrio:SetColor(0,1,0.4)
			end
			itemPrio:SetText(v.prio.." - "..v.spec)
			scroll:AddChild(itemPrio)
		end
	end
					
	table.wipe(stats)
	table.wipe(statsTable)

	local compareBtn = AceGUI:Create("Button")
	compareBtn:SetText("Compare Item")
	compareBtn:SetCallback("OnClick", compareItem)
	compareBtn:SetFullWidth(itemGroup)
	itemGroup:AddChild(compareBtn)

	_, _, dropID = string.find(MyAddon.db.profile.droppedItemLink, "item:(%d+):")

	for _, v in pairs(MyAddon.db.profile.wishlist.items) do
		local _, _, ID = string.find(v.name, "item:(%d+):")
		if ( ID == dropID ) then
			wishLabel:SetText("     On Wish List for: " ..v.use)
			return
		end
	end		

end

function compareItem()
	if (comparing == false) then
		comparing = true

		local i = tablelength(droppedItems)
		i = i - 2
		local height = 375 + (10 * i)

		frame:SetHeight(height)

		local slotId, texture, checkRelic = GetInventorySlotInfo(typeOfItem)

		local equipItem = GetInventoryItemLink("player", slotId)
		sName, sLink, _, iLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(equipItem)
		stats = GetItemStats(sLink, statsTable)
		
		compareGroup = AceGUI:Create("InlineGroup")
		compareGroup:SetTitle("Currently Equipped")
		compareGroup:SetWidth(190)
		compareGroup:SetLayout("List")
		tab:AddChild(compareGroup)
		
		local link = sLink

		local pic = AceGUI:Create("Icon")
		pic:SetImage(sTexture)
		pic:SetWidth(155)
		pic:SetImageSize(40, 40)
		pic:SetCallback("OnEnter", function(pic) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(link) end)
		pic:SetCallback("OnLeave", function(pic) GameTooltip:Hide() end)
		compareGroup:AddChild(pic)

		local label = AceGUI:Create("Label")
		label:SetText(sName)
		label:SetFullWidth(compareGroup)
		label:SetFontObject(GameFontNormalSmall)
		compareGroup:AddChild(label)
		
		WorkoutPrimary()

		EquipPrio()

		local linebreak = AceGUI:Create("Label")
		linebreak:SetText(" ")
		compareGroup:AddChild(linebreak)

		local group = AceGUI:Create("InlineGroup")
		group:SetTitle("Priorities")
		group:SetFullWidth(compareGroup)
		group:SetLayout("Fill")
		group:SetHeight(70)
		compareGroup:AddChild(group)

		scroll = AceGUI:Create("ScrollFrame")
		scroll:SetLayout("Flow")
		group:AddChild(scroll)

		sort(tablePrio, function(a,b) return a.prio > b.prio end)
		for _, v in pairs(tablePrio) do
			if (v.prio > 5) then
				local itemPrio = AceGUI:Create("Label")
				if (v.prio > 13) then
					itemPrio:SetColor(1.0,0,0)
				elseif (v.prio == 13) then
					itemPrio:SetColor(1,0.2,0)
				elseif (v.prio == 12) then
					itemPrio:SetColor(1,0.4,0)
				elseif (v.prio == 11) then
					itemPrio:SetColor(1,0.6,0)
				elseif (v.prio == 10) then
					itemPrio:SetColor(1,0.8,0)
				elseif (v.prio == 9) then
					itemPrio:SetColor(1,1,0)
				elseif (v.prio == 8) then
					itemPrio:SetColor(0.2,1,0)
				elseif (v.prio == 7) then
					itemPrio:SetColor(0,1,0)
				elseif (v.prio == 6) then
					itemPrio:SetColor(0,1,0.4)
				end
				itemPrio:SetText(v.prio.." - "..v.spec)
				scroll:AddChild(itemPrio)
			end
		end

		table.wipe(tablePrio)
		table.wipe(stats)

		if (typeOfItem1 ~= nil) then
			frame:SetWidth(634)
			compareItem1()
		else
			frame:SetWidth(444)
		end
	else
		comparing = false			
		sName, sLink, iRarity, dropppediLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(droppedIDs[1])
		MyAddon.db.profile.isOpen = false
		AceGUI:Release(frame)	
		ActivatePrint()
		tab:SelectTab(0)
	end
end

function compareItem1()
	
	local i = tablelength(droppedItems)
	i = i - 2
	local height = 375 + (8 * i)

	frame:SetHeight(height)
	
	local slotId, texture, checkRelic = GetInventorySlotInfo(typeOfItem1)

	local equipIem = GetInventoryItemLink("player", slotId)
	sName, sLink, _, iLevel, _, sType, sSubType, _, sEquip, sTexture = GetItemInfo(equipIem)
	stats = GetItemStats(sLink, statsTable)
		
	compareGroup = AceGUI:Create("InlineGroup")
	compareGroup:SetTitle("Currently Equipped")
	compareGroup:SetWidth(190)
	compareGroup:SetLayout("List")
	tab:AddChild(compareGroup)
	
	local link = sLink

	local pic = AceGUI:Create("Icon")
	pic:SetImage(sTexture)
	pic:SetWidth(155)
	pic:SetImageSize(40, 40)
	pic:SetCallback("OnEnter", function(pic) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(link) end)
	pic:SetCallback("OnLeave", function(pic) GameTooltip:Hide() end)
	compareGroup:AddChild(pic)

	local label = AceGUI:Create("Label")
	label:SetText(sName)
	label:SetFullWidth(compareGroup)
	label:SetFontObject(GameFontNormalSmall)
	compareGroup:AddChild(label)
		
	WorkoutPrimary()
	
	EquipPrio()

	local linebreak = AceGUI:Create("Label")
	linebreak:SetText(" ")
	compareGroup:AddChild(linebreak)

	local group = AceGUI:Create("InlineGroup")
	group:SetTitle("Priorities")
	group:SetFullWidth(compareGroup)
	group:SetLayout("Fill")
	group:SetHeight(70)
	compareGroup:AddChild(group)

	scroll = AceGUI:Create("ScrollFrame")
	scroll:SetLayout("Flow")
	group:AddChild(scroll)

	sort(tablePrio, function(a,b) return a.prio > b.prio end)
	for _, v in pairs(tablePrio) do
		if (v.prio > 5) then
			local itemPrio = AceGUI:Create("Label")
			if (v.prio > 13) then
				itemPrio:SetColor(1.0,0,0)
			elseif (v.prio == 13) then
				itemPrio:SetColor(1,0.2,0)
			elseif (v.prio == 12) then
				itemPrio:SetColor(1,0.4,0)
			elseif (v.prio == 11) then
				itemPrio:SetColor(1,0.6,0)
			elseif (v.prio == 10) then
				itemPrio:SetColor(1,0.8,0)
			elseif (v.prio == 9) then
				itemPrio:SetColor(1,1,0)
			elseif (v.prio == 8) then
				itemPrio:SetColor(0.2,1,0)
			elseif (v.prio == 7) then
				itemPrio:SetColor(0,1,0)
			elseif (v.prio == 6) then
				itemPrio:SetColor(0,1,0.4)
			end
			itemPrio:SetText(v.prio.." - "..v.spec)
			scroll:AddChild(itemPrio)
		end
	end

	table.wipe(tablePrio)
	table.wipe(stats)
end

function EquipPrio()
	local class = UnitClass("player")
	for i, v in pairs(tablePrio) do
		local _, _, _, restOfString = string.find( v.spec, "(%w+)[%s%p]*(.*)")

		if ((restOfString == "tank) Druid") or (restOfString == "dps) Druid")) then
			restOfString = "Druid"
		end

		if (restOfString ~= class) then
			v.prio = 0
		else
			if (iLevel > dropppediLevel) then
				v.prio = v.prio + 1
			elseif (iLevel < dropppediLevel) then
				v.prio = v.prio - 1
			end
		end
	end
end

function Armour()
	if ( (sEquip == "INVTYPE_CLOAK") or (sSubType == "Miscellaneous") or (sEquip == "INVTYPE_TRINKET")) then
		if (primaryStat == "Intellect") then
			tablePrio = {}
			table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
			table.insert(tablePrio, {spec = "Balance Druid", prio = 5})
			table.insert(tablePrio, {spec = "Arcane Mage", prio = 5})
			table.insert(tablePrio, {spec = "Fire Mage", prio = 5})
			table.insert(tablePrio, {spec = "Frost Mage", prio = 5})
			table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
			table.insert(tablePrio, {spec = "Discipline Priest", prio = 5})
			table.insert(tablePrio, {spec = "Holy Priest", prio = 5})
			table.insert(tablePrio, {spec = "Shadow Priest", prio = 5})
			table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
			table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})
			table.insert(tablePrio, {spec = "Affliction Warlock", prio = 5})
			table.insert(tablePrio, {spec = "Demonology Warlock", prio = 5})
			table.insert(tablePrio, {spec = "Destruction Warlock", prio = 5})					
					
		elseif (primaryStat == "Agility") then
			tablePrio = {}
			table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 5})
			table.insert(tablePrio, {spec = "Feral(dps) Druid", prio = 5})
			table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 5})
			table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 5})
			table.insert(tablePrio, {spec = "Survival Hunter", prio = 5})
			table.insert(tablePrio, {spec = "Enhancement Shaman", prio = 5})
			table.insert(tablePrio, {spec = "Assassination Rogue", prio = 5})
			table.insert(tablePrio, {spec = "Combat Rogue", prio = 5})
			table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 5})
					
		elseif (primaryStat == "Strength") then
			tablePrio = {}
			table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
			table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
			table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
			table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
			table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
			table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
			table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
			table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})

		elseif (primaryStat == "Stamina") then
			tablePrio = {}
			table.insert(tablePrio, {spec = "Blood Death Knight", prio = 10})					
			table.insert(tablePrio, {spec = "Protection Paladin", prio = 10})
			table.insert(tablePrio, {spec = "Protection Warrior", prio = 10})
			table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 10})
		end
		if (sEquip == "INVTYPE_TRINKET") then
			ToolTipScanner(false)
		end
	elseif (sSubType == "Plate") then
		if (primaryStat == "Intellect") then
			tablePrio = {}
			table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})

		else
			tablePrio = {}
			table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
			table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
			table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
			table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
			table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
			table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
			table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
			table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})

		end
	elseif (sSubType == "Mail") then
		if (primaryStat == "Intellect") then
			tablePrio = {}
			table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
			table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})

		else
			tablePrio = {}				
			table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 5})
			table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 5})
			table.insert(tablePrio, {spec = "Survival Hunter", prio = 5})
			table.insert(tablePrio, {spec = "Enhancement Shaman", prio = 5})

		end
	elseif (sSubType == "Leather") then
		if (primaryStat == "Intellect") then
			tablePrio = {}
			table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
			table.insert(tablePrio, {spec = "Balance Druid", prio = 5})

		else
			tablePrio = {}
			table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 5})
			table.insert(tablePrio, {spec = "Feral(dps) Druid", prio = 5})
			table.insert(tablePrio, {spec = "Assassination Rogue", prio = 5})
			table.insert(tablePrio, {spec = "Combat Rogue", prio = 5})
			table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 5})

		end
	elseif (sSubType == "Cloth") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Arcane Mage", prio = 5})
		table.insert(tablePrio, {spec = "Fire Mage", prio = 5})
		table.insert(tablePrio, {spec = "Frost Mage", prio = 5})
		table.insert(tablePrio, {spec = "Discipline Priest", prio = 5})
		table.insert(tablePrio, {spec = "Holy Priest", prio = 5})
		table.insert(tablePrio, {spec = "Shadow Priest", prio = 5})
		table.insert(tablePrio, {spec = "Affliction Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Demonology Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Destruction Warlock", prio = 5})

	elseif (sSubType == "Shields") then	
		table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})
					
	elseif (sSubType == "Relic") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
		table.insert(tablePrio, {spec = "Balance Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(dps) Druid", prio = 5})
		table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Enhancement Shaman", prio = 5})
	end

end

function Weapon()
	if (sSubType == "Bows") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Assassination Rogue", prio = 1})
		table.insert(tablePrio, {spec = "Combat Rogue", prio = 1})
		table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 1})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})
	elseif (sSubType == "Crossbows") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Assassination Rogue", prio = 1})
		table.insert(tablePrio, {spec = "Combat Rogue", prio = 1})
		table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 1})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})
	elseif (sSubType == "Daggers") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
		table.insert(tablePrio, {spec = "Balance Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 3})
		table.insert(tablePrio, {spec = "Feral(dps) Druid", prio = 3})
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Arcane Mage", prio = 5})
		table.insert(tablePrio, {spec = "Fire Mage", prio = 5})
		table.insert(tablePrio, {spec = "Frost Mage", prio = 5})
		table.insert(tablePrio, {spec = "Discipline Priest", prio = 5})
		table.insert(tablePrio, {spec = "Holy Priest", prio = 5})
		table.insert(tablePrio, {spec = "Shadow Priest", prio = 5})
		table.insert(tablePrio, {spec = "Assassination Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Combat Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Enhancement Shaman", prio = 3})
		table.insert(tablePrio, {spec = "Affliction Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Demonology Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Destruction Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 1})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 1})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 1})
	elseif (sSubType == "Guns") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Assassination Rogue", prio = 1})
		table.insert(tablePrio, {spec = "Combat Rogue", prio = 1})
		table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 1})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})
	elseif (sSubType == "Fist Weapons") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
		table.insert(tablePrio, {spec = "Balance Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(dps) Druid", prio = 5})
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Assassination Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Combat Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Enhancement Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})
	elseif (sSubType == "One-Handed Axes") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Assassination Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Combat Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Enhancement Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})				
	elseif (sSubType == "One-Handed Maces") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
		table.insert(tablePrio, {spec = "Balance Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(dps) Druid", prio = 5})
		table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Discipline Priest", prio = 5})
		table.insert(tablePrio, {spec = "Holy Priest", prio = 5})
		table.insert(tablePrio, {spec = "Shadow Priest", prio = 5})
		table.insert(tablePrio, {spec = "Assassination Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Combat Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Enhancement Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})	
	elseif (sSubType == "One-Handed Swords") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 3})
		table.insert(tablePrio, {spec = "Arcane Mage", prio = 5})
		table.insert(tablePrio, {spec = "Fire Mage", prio = 5})
		table.insert(tablePrio, {spec = "Frost Mage", prio = 5})
		table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Assassination Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Combat Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Affliction Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Demonology Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Destruction Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})	
	elseif (sSubType == "Polearms") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
		table.insert(tablePrio, {spec = "Balance Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(dps) Druid", prio = 5})
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Enhancement Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})	
	elseif (sSubType == "Staves") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
		table.insert(tablePrio, {spec = "Balance Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 5})
		table.insert(tablePrio, {spec = "Feral(dps) Druid", prio = 5})
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Arcane Mage", prio = 5})
		table.insert(tablePrio, {spec = "Fire Mage", prio = 5})
		table.insert(tablePrio, {spec = "Frost Mage", prio = 5})
		table.insert(tablePrio, {spec = "Discipline Priest", prio = 5})
		table.insert(tablePrio, {spec = "Holy Priest", prio = 5})
		table.insert(tablePrio, {spec = "Shadow Priest", prio = 5})
		table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Enhancement Shaman", prio = 5})
		table.insert(tablePrio, {spec = "Affliction Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Demonology Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Destruction Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})
	elseif (sSubType == "Thrown") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Assassination Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Combat Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})
	elseif (sSubType == "Two-Handed Axes") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})	
	elseif (sSubType == "Two-Handed Maces") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})	
	elseif (sSubType == "Two-Handed Swords") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
		table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Survival Hunter", prio = 5})
		table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
		table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
		table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})	
	elseif (sSubType == "Wands") then
		tablePrio = {}
		table.insert(tablePrio, {spec = "Arcane Mage", prio = 5})
		table.insert(tablePrio, {spec = "Fire Mage", prio = 5})
		table.insert(tablePrio, {spec = "Frost Mage", prio = 5})
		table.insert(tablePrio, {spec = "Discipline Priest", prio = 5})
		table.insert(tablePrio, {spec = "Holy Priest", prio = 5})
		table.insert(tablePrio, {spec = "Shadow Priest", prio = 5})
		table.insert(tablePrio, {spec = "Affliction Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Demonology Warlock", prio = 5})
		table.insert(tablePrio, {spec = "Destruction Warlock", prio = 5})
	end

	ToolTipScanner(false)
end

function Misc()
	local left, left1, left2, left3, name = strsplit(" ", sName, 5)
	tablePrio = {}
	if (name == "Conqueror") then
		table.insert(tablePrio, {spec = "Paladin", prio = 14})
		table.insert(tablePrio, {spec = "Priest", prio = 14})
		table.insert(tablePrio, {spec = "Warlock", prio = 14})
	elseif (name == "Protector") then
		table.insert(tablePrio, {spec = "Hunter", prio = 14}) 
		table.insert(tablePrio, {spec = "Shaman", prio = 14}) 
		table.insert(tablePrio, {spec = "Warrior", prio = 14}) 
	elseif (name == "Vanquisher") then
		table.insert(tablePrio, {spec = "Druid", prio = 14})
		table.insert(tablePrio, {spec = "Death Knight", prio = 14})
		table.insert(tablePrio, {spec = "Mage", prio = 14})
		table.insert(tablePrio, {spec = "Rogue", prio = 14})
	end
end

function WorkoutStats()
	if (sType == "Armor") then
		Armour()
	elseif (sType == "Weapon") then
		Weapon()
	elseif (sType == "Miscellaneous") then
		Misc()
	end
		
	for stat, value in pairs(stats) do			
		if (_G[stat] == "Agility") then
			Agility()				
		elseif (_G[stat] == "Intellect") then
			Intellect()
		elseif (_G[stat] == "Strength") then
			Strength()
		end

		if (sType ~= "Weapon") then
			if (_G[stat] == "Critical Strike Rating") then
				Crit()
			end

			if (_G[stat] == "Haste Rating") then
				Haste()
			end

			if (_G[stat] == "Mastery Rating") then
				Mastery()
			end

			if (_G[stat] == "Hit Rating") then
				Hit()
			end

			if (_G[stat] == "Expertise Rating") then
				Expertise()
			end

			if (_G[stat] == "Parry Rating") then
				Dodge()
			end

			if (_G[stat] == "Dodge Rating") then
				Parry()
			end

			if (_G[stat] == "Spirit") then
				Spirit()
			end
		end
	end
end

function ToolTipScanner(lockCheck)
	
	CreateFrame( "GameTooltip", "MyScanningTooltip", nil, "GameTooltipTemplate" ); -- Tooltip name cannot be nil
	MyScanningTooltip:SetOwner( WorldFrame, "ANCHOR_NONE" );
	MyScanningTooltip:ClearLines()
	MyScanningTooltip:SetHyperlink(sLink)
	
	if (lockCheck == true) then	
		if (sType == "Miscellaneous") then
			EnumerateTooltipLines_helperLockbox(MyScanningTooltip:GetRegions())
		end
	else
		EnumerateTooltipLines_helper(MyScanningTooltip:GetRegions())
	end
	
end

function EnumerateTooltipLines_helperLockbox(...)
	for i = 1, select("#", ...) do
        local region = select(i, ...)
        if region and region:GetObjectType() == "FontString" then
            local text = region:GetText() -- string or nil
			if (text ~= nil) then
				local startPos, endPos, firstWord, restOfString = string.find( text, "(%w+)[%s%p]*(.*)")

				if (firstWord == "Locked") then
					isLockbox = true
				end
			end
		end
	end
end

function EnumerateTooltipLines_helper(...)
    for i = 1, select("#", ...) do
        local region = select(i, ...)
        if region and region:GetObjectType() == "FontString" then
            local text = region:GetText() -- string or nil
			if (text ~= nil) then
				local startPos, endPos, firstWord, restOfString = string.find( text, "(%w+)[%s%p]*(.*)")
				
				local count = 0
				if ((firstWord == "Equip") or (firstWord == "Use")) then
					
					local foundWord = string.find(restOfString, "spell power")
					if (foundWord ~= nil) then
						for _ in pairs(tablePrio) do count = count + 1 end 
						
						if (count == 0) then
							tablePrio = {}
							table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
							table.insert(tablePrio, {spec = "Balance Druid", prio = 5})
							table.insert(tablePrio, {spec = "Arcane Mage", prio = 5})
							table.insert(tablePrio, {spec = "Fire Mage", prio = 5})
							table.insert(tablePrio, {spec = "Frost Mage", prio = 5})
							table.insert(tablePrio, {spec = "Discipline Priest", prio = 5})
							table.insert(tablePrio, {spec = "Holy Priest", prio = 5})
							table.insert(tablePrio, {spec = "Shadow Priest", prio = 5})
							table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
							table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})
							table.insert(tablePrio, {spec = "Affliction Warlock", prio = 5})
							table.insert(tablePrio, {spec = "Demonology Warlock", prio = 5})
							table.insert(tablePrio, {spec = "Destruction Warlock", prio = 5})						
							table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
						end
					end
					
					foundWord = string.find(restOfString, "harmful spells")
					if (foundWord ~= nil) then
						for _ in pairs(tablePrio) do count = count + 1 end 
						
						if (count == 0) then
							tablePrio = {}
							table.insert(tablePrio, {spec = "Balance Druid", prio = 5})
							table.insert(tablePrio, {spec = "Arcane Mage", prio = 5})
							table.insert(tablePrio, {spec = "Fire Mage", prio = 5})
							table.insert(tablePrio, {spec = "Frost Mage", prio = 5})
							table.insert(tablePrio, {spec = "Shadow Priest", prio = 5})
							table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
							table.insert(tablePrio, {spec = "Affliction Warlock", prio = 5})
							table.insert(tablePrio, {spec = "Demonology Warlock", prio = 5})
							table.insert(tablePrio, {spec = "Destruction Warlock", prio = 5})
						end
					end

					foundWord = string.find(restOfString, "harmful spellcasts")
					if (foundWord ~= nil) then
						for _ in pairs(tablePrio) do count = count + 1 end 
						
						if (count == 0) then
							tablePrio = {}
							table.insert(tablePrio, {spec = "Balance Druid", prio = 5})
							table.insert(tablePrio, {spec = "Arcane Mage", prio = 5})
							table.insert(tablePrio, {spec = "Fire Mage", prio = 5})
							table.insert(tablePrio, {spec = "Frost Mage", prio = 5})
							table.insert(tablePrio, {spec = "Shadow Priest", prio = 5})
							table.insert(tablePrio, {spec = "Elemental Shaman", prio = 5})
							table.insert(tablePrio, {spec = "Affliction Warlock", prio = 5})
							table.insert(tablePrio, {spec = "Demonology Warlock", prio = 5})
							table.insert(tablePrio, {spec = "Destruction Warlock", prio = 5})
						else
							for _, value in ipairs(tablePrio) do
								if ((value.spec == "Balance Druid") or (value.spec == "Shadow Priest") or (value.spec == "Elemental Shaman") or (value.spec == "Fire Mage") or (value.spec == "Frost Mage") or (value.spec == "Arcane Mage") or (value.spec == "Affliction Warlock") or (value.spec == "Destruction Warlock") or (value.spec == "Demonology Warlock")) then
									value.prio = value.prio + 2
								end
							end
						end
					end

					local foundWord = string.find(restOfString, "healing spells")
					if (foundWord ~= nil) then
						for _ in pairs(tablePrio) do count = count + 1 end 
						
						if (count == 0) then
							tablePrio = {}
							table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
							table.insert(tablePrio, {spec = "Discipline Priest", prio = 5})
							table.insert(tablePrio, {spec = "Holy Priest", prio = 5})						
							table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})												
							table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
						end
					end
					
					foundWord = string.find(restOfString, "attacks")
					if (foundWord ~= nil) then
						for _ in pairs(tablePrio) do count = count + 1 end 
						if (count == 0) then
							tablePrio = {}
							table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})
							table.insert(tablePrio, {spec = "Frost Death Knight", prio = 5})
							table.insert(tablePrio, {spec = "Unholy Death Knight", prio = 5})
							table.insert(tablePrio, {spec = "Retribution Paladin", prio = 5})
							table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
							table.insert(tablePrio, {spec = "Arms Warrior", prio = 5})
							table.insert(tablePrio, {spec = "Fury Warrior", prio = 5})
							table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})
							table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 5})
							table.insert(tablePrio, {spec = "Feral(dps) Druid", prio = 5})
							table.insert(tablePrio, {spec = "Beast Mastery Hunter", prio = 5})
							table.insert(tablePrio, {spec = "Marksmanship Hunter", prio = 5})
							table.insert(tablePrio, {spec = "Survival Hunter", prio = 5})
							table.insert(tablePrio, {spec = "Enhancement Shaman", prio = 5})
							table.insert(tablePrio, {spec = "Assassination Rogue", prio = 5})
							table.insert(tablePrio, {spec = "Combat Rogue", prio = 5})
							table.insert(tablePrio, {spec = "Subtlety Rogue", prio = 5})
						else
							for _, value in ipairs(tablePrio) do
								if ((value.spec == "Restoration Druid") or (value.spec == "Holy Paladin") or (value.spec == "Discipline Priest") or (value.spec == "Holy Priest") or (value.spec == "Restoration Shaman")) then
									value.prio = value.prio - 2
								else
									value.prio = value.prio + 2
								end
							end
						
						end
					end

					foundWord = string.find(restOfString, "maximum health")
					if (foundWord ~= nil) then
						for _ in pairs(tablePrio) do count = count + 1 end 
						
						if (count == 0) then
							tablePrio = {}
							table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})							
							table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})							
							table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})
							table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 5})
							
						else
							for _, value in ipairs(tablePrio) do
								if ((value.spec == "Blood Death Knight") or (value.spec == "Protection Paladin") or (value.spec == "Protection Warrior") or (value.spec == "Feral(tank) Druid")) then
									value.prio = value.prio + 2
								else
									value.prio = value.prio - 2
								end
							end
						
						end
					end

					foundWord = string.find(restOfString, "parry")
					if (foundWord ~= nil) then
						for _ in pairs(tablePrio) do count = count + 1 end 
						
						if (count == 0) then
							tablePrio = {}
							table.insert(tablePrio, {spec = "Blood Death Knight", prio = 5})							
							table.insert(tablePrio, {spec = "Protection Paladin", prio = 5})
							table.insert(tablePrio, {spec = "Protection Warrior", prio = 5})							
							table.insert(tablePrio, {spec = "Feral(tank) Druid", prio = 5})
						end
					end

					foundWord = string.find(restOfString, "mana")
					if (foundWord ~= nil) then
						for _ in pairs(tablePrio) do count = count + 1 end 
						
						if (count == 0) then
							tablePrio = {}
							table.insert(tablePrio, {spec = "Restoration Druid", prio = 5})
							table.insert(tablePrio, {spec = "Discipline Priest", prio = 5})
							table.insert(tablePrio, {spec = "Holy Priest", prio = 5})						
							table.insert(tablePrio, {spec = "Restoration Shaman", prio = 5})												
							table.insert(tablePrio, {spec = "Holy Paladin", prio = 5})
						end
						Spirit()
					end

					local findStat = string.find(restOfString, "haste")
					if (findStat ~= nil) then
						Haste()
					end

					findStat = string.find(restOfString, "critical")
					if (findStat ~= nil) then
						Crit()
					end

					findStat = string.find(restOfString, "mastery")
					if (findStat ~= nil) then
						Mastery()
					end

					findStat = string.find(restOfString, "spirit")
					if (findStat ~= nil) then
						Spirit()
					end

					findStat = string.find(restOfString, "dodge")
					if (findStat ~= nil) then
						Dodge()
					end
					
					findStat = string.find(restOfString, "parry")
					if (findStat ~= nil) then
						Parry()
					end

					findStat = string.find(restOfString, "expertise")
					if (findStat ~= nil) then
						Expertise()
					end

					findStat = string.find(restOfString, "hit")
					if (findStat ~= nil) then
						Hit()
					end

					if (sType ~= "Weapon") then
						findStat = string.find(restOfString, "Intellect")
						if (findStat ~= nil) then
							Intellect()
						end

						findStat = string.find(restOfString, "Strength")
						if (findStat ~= nil) then
							Strength()
						end

						findStat = string.find(restOfString, "Agility")
						if (findStat ~= nil) then
							Agility()
						end
					end

					findStat = string.find(restOfString, "heal")
					if (findStat ~= nil) then
						for _, value in ipairs(tablePrio) do
							if ((value.spec == "Restoration Druid") or (value.spec == "Holy Paladin") or (value.spec == "Discipline Priest") or (value.spec == "Holy Priest") or (value.spec == "Restoration Shaman")) then
								value.prio = value.prio + 2
							else
								value.prio = value.prio - 2
							end
						end
					end

					findStat = string.find(restOfString, "deal damage")
					if (findStat ~= nil) then
						for _, value in ipairs(tablePrio) do
							if ((value.spec == "Restoration Druid") or (value.spec == "Holy Paladin") or (value.spec == "Discipline Priest") or (value.spec == "Holy Priest") or (value.spec == "Restoration Shaman")) then
								value.prio = value.prio - 2
							else
								value.prio = value.prio + 2
							end
						end
					end

					findStat = string.find(restOfString, "damage dealing")
					if (findStat ~= nil) then
						for _, value in ipairs(tablePrio) do
							if ((value.spec == "Restoration Druid") or (value.spec == "Holy Paladin") or (value.spec == "Discipline Priest") or (value.spec == "Holy Priest") or (value.spec == "Restoration Shaman") or (value.spec == "Blood Death Knight") or (value.spec == "Protection Warrior") or (value.spec == "Protection Paladin")) then
								value.prio = value.prio - 2
							else
								value.prio = value.prio + 2
							end
						end
					end
				end
			end
        end
    end
end

function Agility()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Feral(dps) Druid") or (value.spec == "Feral(tank) Druid") or (value.spec == "Enhancement Shaman") or (value.spec == "Subtlety Rogue") or (value.spec == "Combat Rogue") or (value.spec == "Assassination Rogue") or (value.spec == "Beast Mastery Hunter")  or (value.spec == "Survival Hunter") or (value.spec == "Marksmanship Hunter")) then
			value.prio = value.prio + 5		
		else
			value.prio = value.prio - 5	
		end  
	end
	
end

function Intellect()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Restoration Druid") or (value.spec == "Balance Druid") or (value.spec == "Holy Paladin") or (value.spec == "Discipline Priest") or (value.spec == "Holy Priest") or (value.spec == "Shadow Priest") or (value.spec == "Restoration Shaman") or (value.spec == "Elemental Shaman") or (value.spec == "Fire Mage") or (value.spec == "Frost Mage") or (value.spec == "Arcane Mage") or (value.spec == "Affliction Warlock") or (value.spec == "Destruction Warlock") or (value.spec == "Demonology Warlock")) then
			value.prio = value.prio + 5
		else
			value.prio = value.prio - 5	
		end  
	end
end

function Strength()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Unholy Death Knight") or (value.spec == "Frost Death Knight") or (value.spec == "Arms Warrior") or (value.spec == "Fury Warrior") or (value.spec == "Retribution Paladin")) then
			value.prio = value.prio + 5
		elseif ((value.spec == "Blood Death Knight") or (value.spec == "Protection Warrior") or (value.spec == "Protection Paladin")) then
			value.prio = value.prio + 3
		else
			value.prio = value.prio - 5	
		end  
	end
end

function Crit()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Arms Warrior") or (value.spec == "Fury Warrior") or (value.spec == "Fire Mage") or (value.spec == "Frost Mage") or (value.spec == "Beast Mastery Hunter") or (value.spec == "Survival Hunter")) then
			value.prio = value.prio + 2
		elseif ((value.spec == "Feral(dps) Druid") or (value.spec == "Feral(tank) Druid") or (value.spec == "Retribution Paladin") or (value.spec == "Affliction Warlock") or (value.spec == "Destruction Warlock") or (value.spec == "Enhancement Shaman") or (value.spec == "Restoration Shaman") or (value.spec == "Subtlety Rogue") or (value.spec == "Marksmanship Hunter")) then
			value.prio = value.prio + 1
		end  
	end
end

function Haste()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Frost Death Knight") or (value.spec == "Unholy Death Knight") or (value.spec == "Balance Druid") or (value.spec == "Restoration Druid") or (value.spec == "Holy Paladin") or (value.spec == "Arcane Mage") or (value.spec == "Shadow Priest") or (value.spec == "Holy Priest") or (value.spec == "Affliction Warlock") or (value.spec == "Destruction Warlock") or (value.spec == "Elemental Shaman") or (value.spec == "Subtlety Rogue") or (value.spec == "Combat Rogue") or (value.spec == "Marksmanship Hunter")) then
			value.prio = value.prio + 2
		elseif ((value.spec == "Feral(dps) Druid") or (value.spec == "Fire Mage") or (value.spec == "Frost Mage") or (value.spec == "Discipline Priest") or (value.spec == "Demonology Warlock") or (value.spec == "Restoration Shaman") or (value.spec == "Assassination Rogue") or (value.spec == "Beast Mastery Hunter")  or (value.spec == "Survival Hunter")) then
			value.prio = value.prio + 1
		end  
	end
end

function Mastery()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Retribution Paladin") or (value.spec == "Discipline Priest") or (value.spec == "Demonology Warlock") or (value.spec == "Enhancement Shaman") or (value.spec == "Assassination Rogue")) then
			value.prio = value.prio + 2
		elseif ((value.spec == "Unholy Death Knight") or (value.spec == "Frost Death Knight") or (value.spec == "Blood Death Knight") or (value.spec == "Balance Druid") or (value.spec == "Retoration Druid") or (value.spec == "Feral(dps) Druid") or (value.spec == "Feral(tank) Druid") or (value.spec == "Arms Warrior")  or (value.spec == "Protection Warrior") or (value.spec == "Fury Warrior") or (value.spec == "Protection Paladin") or (value.spec == "Holy Paladin") or (value.spec == "Arcane Mage") or (value.spec == "Shadow Priest") or (value.spec == "Holy Priest") or (value.spec == "Elemental Shaman") or (value.spec == "Restoration Shaman") or (value.spec == "Combat Rogue") or (value.spec == "Beast Mastery Hunter")) then
			value.prio = value.prio + 1
		end  
	end
end

function Hit()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Blood Death Knight") or (value.spec == "Feral(tank) Druid") or (value.spec == "Protection Paladin") or (value.spec == "Protection Warrior") or (value.spec == "Restoration Druid") or (value.spec == "Holy Paladin") or (value.spec == "Discipline Priest") or (value.spec == "Holy Priest") or (value.spec == "Restoration Shaman")) then
		
		else
			value.prio = value.prio + 1
		end  
	end
end

function Spirit()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Restoration Druid") or (value.spec == "Holy Paladin") or (value.spec == "Discipline Priest") or (value.spec == "Holy Priest") or (value.spec == "Restoration Shaman")) then
			value.prio = value.prio + 2
		elseif ((value.spec == "Balance Druid") or (value.spec == "Shadow Priest") or (value.spec == "Elemental Shaman")) then
			value.prio = value.prio + 1
		else
			value.prio = value.prio - 2	
		end  
	end
end

function Expertise()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Unholy Death Knight") or (value.spec == "Frost Death Knight") or (value.spec == "Feral(dps) Druid") or (value.spec == "Arms Warrior") or (value.spec == "Fury Warrior") or (value.spec == "Retribution Paladin") or (value.spec == "Enhancement Shaman") or (value.spec == "Subtlety Rogue") or (value.spec == "Combat Rogue") or (value.spec == "Assassination Rogue")) then
			value.prio = value.prio + 1		
		end  
	end
end

function Dodge()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Blood Death Knight") or (value.spec == "Feral(tank) Druid") or (value.spec == "Protection Paladin") or (value.spec == "Protection Warrior")) then
			value.prio = value.prio + 2		
		else
			value.prio = value.prio - 5	
		end  
	end
end

function Parry()
	for _, value in ipairs(tablePrio) do
		if ((value.spec == "Blood Death Knight") or (value.spec == "Protection Paladin") or (value.spec == "Protection Warrior")) then
			value.prio = value.prio + 2	
		elseif (value.spec == "Feral(tank) Druid") then
			value.prio = value.prio + 1
		else
			value.prio = value.prio - 5	
		end  
	end
end

function WorkOutEPGP()
	if (MyAddon.db.profile.inGuild == true) then
		if (sType == "Miscellaneous") then
			local name, left = strsplit(" ", sName, 2)
			if (name == "Gauntlets") then
				typeOfItem = "HandsSlot"
				iEPGPCost = MyAddon.db.profile.custom.GlovesGP
			elseif (name == "Pauldrons" or name == "Mantle" or name == "Shoulders") then
				typeOfItem = "ShoulderSlot"
				iEPGPCost = MyAddon.db.profile.custom.ShouldersGP
			elseif (name == "Chestguard" or name == "Chest") then
				typeOfItem = "ChestSlot"
				iEPGPCost = MyAddon.db.profile.custom.ChestGP	
			elseif (name == "Leggings") then
				typeOfItem = "LegsSlot"
				iEPGPCost = MyAddon.db.profile.custom.LegsGP	
			elseif (name == "Crown" or name == "Helm") then
				typeOfItem = "HeadSlot"
				iEPGPCost = MyAddon.db.profile.custom.HelmGP		
			end
		elseif (sEquip == "INVTYPE_HEAD") then
			typeOfItem = "HeadSlot"
			iEPGPCost = MyAddon.db.profile.custom.HelmGP
		elseif (sEquip == "INVTYPE_LEGS") then
			typeOfItem = "LegsSlot"
			iEPGPCost = MyAddon.db.profile.custom.LegsGP	
		elseif (sEquip == "INVTYPE_CHEST" or sEquip == "INVTYPE_ROBE") then
			typeOfItem = "ChestSlot"
			iEPGPCost = MyAddon.db.profile.custom.ChestGP
		elseif (sEquip == "INVTYPE_NECK") then
			typeOfItem = "NeckSlot"
			iEPGPCost = MyAddon.db.profile.custom.NeckGP
		elseif (sEquip == "INVTYPE_CLOAK") then
			typeOfItem = "BackSlot"
			iEPGPCost = MyAddon.db.profile.custom.CloakGP
		elseif (sEquip == "INVTYPE_WRIST") then
			typeOfItem = "WristSlot"
			iEPGPCost = MyAddon.db.profile.custom.WristGP
		elseif (sEquip == "INVTYPE_FINGER") then
			typeOfItem = "Finger0Slot"
			typeOfItem1 = "Finger1Slot"
			iEPGPCost = MyAddon.db.profile.custom.RingGP
		elseif (sEquip == "INVTYPE_SHOULDER") then
			typeOfItem = "ShoulderSlot"
			iEPGPCost = MyAddon.db.profile.custom.ShouldersGP
		elseif (sEquip == "INVTYPE_HAND") then
			typeOfItem = "HandsSlot"
			iEPGPCost = MyAddon.db.profile.custom.GlovesGP
		elseif (sEquip == "INVTYPE_WAIST") then
			typeOfItem = "WaistSlot"
			iEPGPCost = MyAddon.db.profile.custom.WaistGP
		elseif (sEquip == "INVTYPE_FEET") then
			typeOfItem = "FeetSlot"
			iEPGPCost = MyAddon.db.profile.custom.BootsGP
		elseif (sEquip == "INVTYPE_TRINKET") then
			typeOfItem = "Trinket0Slot"
			typeOfItem1 = "Trinket1Slot"
			iEPGPCost = MyAddon.db.profile.custom.TrinketGP
		elseif (sEquip == "INVTYPE_SHIELD" or sEquip == "INVTYPE_WEAPONOFFHAND" or sEquip == "INVTYPE_HOLDABLE") then
			typeOfItem = "SecondaryHandSlot"
			iEPGPCost = MyAddon.db.profile.custom.OffhandGP
		elseif (sEquip == "INVTYPE_2HWEAPON") then
			typeOfItem = "MainHandSlot"
			iEPGPCost = MyAddon.db.profile.custom.WeaponGP
		elseif (sEquip == "INVTYPE_WEAPONMAINHAND" or sEquip == "INVTYPE_WEAPON") then
			typeOfItem = "MainHandSlot"
			iEPGPCost = MyAddon.db.profile.custom.MainhandGP
		elseif (sEquip == "INVTYPE_RANGED" or sEquip == "INVTYPE_RANGEDRIGHT" or sEquip == "INVTYPE_THROWN") then
			typeOfItem = "RangedSlot"
			iEPGPCost = MyAddon.db.profile.custom.RangedGP
		else
			iEPGPCost = 0
		end
	else
		local gpCost
		
		if (iRarity == 4) then
			gpCost = (dropppediLevel - 1.3) / 1.3
		elseif (iRarity == 3) then
			gpCost = (dropppediLevel - 1.84) / 1.6
		elseif (iRarity == 2) then
			gpCost = (dropppediLevel - 4) / 2
		end
		gpCost = (gpCost * gpCost) * 0.04
		if (sType == "Miscellaneous") then
			local name, left = strsplit(" ", sName, 2)
			if (name == "Gauntlets") then
				typeOfItem = "HandsSlot"
				iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.GlovesGP)
			elseif (name == "Pauldrons" or name == "Mantle" or name == "Shoulders") then
				typeOfItem = "ShoulderSlot"
				iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.ShouldersGP)
			elseif (name == "Chestguard" or name == "Chest") then
				typeOfItem = "ChestSlot"
				iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.ChestGP)	
			elseif (name == "Leggings") then
				typeOfItem = "LegsSlot"
				iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.LegsGP)	
			elseif (name == "Crown" or name == "Helm") then
				typeOfItem = "HeadSlot"
				iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.HelmGP)		
			end
		elseif (sEquip == "INVTYPE_HEAD") then
			typeOfItem = "HeadSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.HelmGP)
		elseif (sEquip == "INVTYPE_LEGS") then
			typeOfItem = "LegsSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.LegsGP)	
		elseif (sEquip == "INVTYPE_CHEST" or sEquip == "INVTYPE_ROBE") then
			typeOfItem = "ChestSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.ChestGP)
		elseif (sEquip == "INVTYPE_NECK") then
			typeOfItem = "NeckSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.NeckGP)
		elseif (sEquip == "INVTYPE_CLOAK") then
			typeOfItem = "BackSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.CloakGP)
		elseif (sEquip == "INVTYPE_WRIST") then
			typeOfItem = "WristSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.WristGP)
		elseif (sEquip == "INVTYPE_FINGER") then
			typeOfItem = "Finger0Slot"
			typeOfItem1 = "Finger1Slot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.RingGP)
		elseif (sEquip == "INVTYPE_SHOULDER") then
			typeOfItem = "ShoulderSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.ShouldersGP)
		elseif (sEquip == "INVTYPE_HAND") then
			typeOfItem = "HandsSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.GlovesGP)
		elseif (sEquip == "INVTYPE_WAIST") then
			typeOfItem = "WaistSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.WaistGP)
		elseif (sEquip == "INVTYPE_FEET") then
			typeOfItem = "FeetSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.BootsGP)
		elseif (sEquip == "INVTYPE_TRINKET") then
			typeOfItem = "Trinket0Slot"
			typeOfItem1 = "Trinket1Slot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.TrinketGP)
		elseif (sEquip == "INVTYPE_SHIELD" or sEquip == "INVTYPE_WEAPONOFFHAND" or sEquip == "INVTYPE_HOLDABLE") then
			typeOfItem = "SecondaryHandSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.OffhandGP)
		elseif (sEquip == "INVTYPE_2HWEAPON") then
			typeOfItem = "MainHandSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.WeaponGP)
		elseif (sEquip == "INVTYPE_WEAPONMAINHAND" or sEquip == "INVTYPE_WEAPON") then
			typeOfItem = "MainHandSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.MainhandGP)
		elseif (sEquip == "INVTYPE_RANGED" or sEquip == "INVTYPE_RANGEDRIGHT" or sEquip == "INVTYPE_THROWN") then
			typeOfItem = "RangedSlot"
			iEPGPCost = floor(gpCost * MyAddon.db.profile.epgp.RangedGP)
		else
			iEPGPCost = 0
		end
	end
end

function WorkoutPrimary()
	primaryStat = nil
	for stat, value in pairs(stats) do
		if (_G[stat] == "Agility") then
			primaryStat = "Agility"				
		elseif (_G[stat] == "Intellect") then
			primaryStat = "Intellect"
		elseif (_G[stat] == "Strength") then
			primaryStat = "Strength"
		end
	end

	if (primaryStat == nil) then
		for stat, value in pairs(stats) do
			if (_G[stat] == "Stamina") then
				primaryStat = "Stamina"
			end
		end
	end
		
	WorkoutStats()
end

function LoadFramePosition()
	MyAddon.db = LibStub("AceDB-3.0"):New("EPGPLootingGuideDB1", defaults)
	frame:ClearAllPoints()
	frame:SetPoint(MyAddon.db.profile.point, UIParent, MyAddon.db.profile.relPoint, MyAddon.db.profile.x, MyAddon.db.profile.y)
end

function SaveFramePosition()
	local point, _, relativePoint, xOffset, yOffset = frame:GetPoint()
	if (MyAddon.db.profile.x ~= xOffset) or (MyAddon.db.profile.y ~= yOffset) then
		MyAddon.db.profile.point = point
		MyAddon.db.profile.relPoint = relativePoint
		MyAddon.db.profile.x = xOffset
		MyAddon.db.profile.y = yOffset
	end
end

function tablelength(T) 
  local count = 0 
  for _ in pairs(T) do count = count + 1 end 
  return count 
end

function WishListFrame()
	isOpen = true				
	local wishFrame = AceGUI:Create("Frame")
	firstcheck = false 

	wishFrame:SetTitle("Wish List")
	wishFrame:SetCallback("OnClose", function(frame) isOpen = false AceGUI:Release(wishFrame) end)			
	wishFrame:SetLayout("Flow")
	wishFrame:SetWidth(400)
	wishFrame:SetHeight(500)
	wishFrame:EnableResize(Hide)
	
	wishText = AceGUI:Create("EditBox")
	wishText:SetLabel("Enter Item:")
	wishFrame:AddChild(wishText)

	local useList = {["choice1"] = "Main Spec", ["choice2"] = "Off Spec", ["choice3"] ="Transmog"}

	local wishDrop = AceGUI:Create("Dropdown")
	wishDrop:SetLabel("What would you like the item for:")
	wishDrop:SetList(useList)
	wishDrop:SetValue("choice1")
	wishFrame:AddChild(wishDrop)

	local wishGroup = AceGUI:Create("InlineGroup")
	wishGroup:SetTitle("Wish List Items")
	wishGroup:SetFullWidth(wishFrame)
	wishGroup:SetFullHeight(true)
	wishGroup:SetLayout("Fill")
	wishFrame:AddChild(wishGroup)
	
	wishText:SetCallback("OnEnterPressed", function(wishText)
	local name, link = GetItemInfo(wishText:GetText())
	if ( name ~= nil ) then
		if (IsEquippableItem(link) ~= nil) then 
			table.insert(MyAddon.db.profile.wishlist.items, {name = link, use = useList[wishDrop:GetValue()]})
			wishText:SetText("")
			wishFrame:SetStatusText("") 
			ItemList(wishFrame, wishGroup)
			droppedText = ""
		else
			wishFrame:SetStatusText("You can't use this item")
		end
	else
		wishFrame:SetStatusText("Item doesn't excist")
	end 
	end)

	if (tablelength(MyAddon.db.profile.wishlist.items) > 0) then
		ItemList(wishFrame, wishGroup)
	end
end

function ItemList(wishframe, container)
	
	container:ReleaseChildren()

	local scrollList = AceGUI:Create("ScrollFrame")
	scrollList:SetLayout("Flow")
	container:AddChild(scrollList)

	for i, v in pairs(MyAddon.db.profile.wishlist.items) do
		local itemList = AceGUI:Create("InteractiveLabel")
		itemList:SetText(v.name)
		itemList:SetFullWidth(true)
		itemList:SetFontObject(GameFontNormal)
		itemList:SetCallback("OnClick", function(button) MyAddon:Print("Deleted this: "..v.name) table.remove(MyAddon.db.profile.wishlist.items, i) GameTooltip:Hide() ItemList(wishframe, container) end)
		itemList:SetCallback("OnEnter", function(itemList) GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR") GameTooltip:SetHyperlink(v.name) end)
		itemList:SetCallback("OnLeave", function(itemList) GameTooltip:Hide() end)
		scrollList:AddChild(itemList)

		local itemSpacer = AceGUI:Create("Label")
		itemSpacer:SetText(v.use)
		scrollList:AddChild(itemSpacer)
	end
end